/*****************************************************************************/
// decompress.cpp
// Douglas Kane 5 OCT 2001
// foster_fc@yahoo.com
// This file is released to the public domain without restriction. I'd
// appreciate credit if this sees any use. Please post or e-mail me code
// updates for any improvements that are made by others. 
//                                            
// Decompress test code
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "decompress.h"
#include "tcBitstream.h"
#include "tcDecoder.h"

// example use of Bitstream and Decoder objects for 
// PKWARE Data Compression Library decompression
void Decompress(char *azInFile, char *azOutFile) {
   FILE *lpInFile, *lpOutFile;

   /* open files */
   lpInFile = fopen(azInFile,"rb");
   if(lpInFile==NULL) {return;}

   lpOutFile = fopen(azOutFile,"wb");
   if(lpOutFile==NULL) {return;}

   /* initialize Bitstream and Decoder objects */
   tcBitstream lcBitstream(lpInFile);
   tcDecoder lcDecoder(&lcBitstream);


   /* invoke decode method */
//   lcDecoder.Decode(laBuffer,&lnSize,10240);
	lcDecoder.Decode(lpOutFile);
   /* save results to file */
//   fwrite(laBuffer,1,lnSize,lpOutFile);

   fclose(lpInFile);
   fclose(lpOutFile);
}